# @billogram/foundation-data-provider

> A React component for fetching data

## Install

```
yarn add @billogram/foundation-data-provider
```

## Usage

```tsx
import {
    FoundationDataProvider,
} from '@billogram/foundation-data-provider';
```

See [types](src/types.ts) for exported types.

### [`FoundationDataProvider`](src/FoundationDataProvider.tsx)

```tsx
import {
    Data,
    Options,
} from './types';


function DataFetchingComponent() {
    function fetchData(options: Options): Promise<Data> {
        return Promise.resolve({});
    }

    const initialFetchDataOptions: Options = {};

    return (
        <FoundationDataProvider
            fetchData={ fetchData }
            initialFetchDataOptions={ initialFetchDataOptions }>
            { ({ fetch, result }) => (
                <div>...</div>
            ) }
        </FoundationDataProvider>
    );
}
```

## Note

This library is being published with our use cases in mind and is not necessarily meant to be consumed by the broader public. We probably won't take your feature requests unless they align with our own needs.

## License

MIT
