import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import { useCallback, useEffect, useRef, useState } from 'react';
import { makeCancelablePromise } from '@billogram/cancelable-promise';

function noop() {}

export default function FoundationDataProvider(_ref) {
  var children = _ref.children,
      fetchData = _ref.fetchData,
      initialFetchDataOptions = _ref.initialFetchDataOptions;
  var cancel = useRef(noop);

  var _useState = useState({
    state: 'fetching-initial'
  }),
      _useState2 = _slicedToArray(_useState, 2),
      result = _useState2[0],
      setResult = _useState2[1];

  var fetch = useCallback(
  /*#__PURE__*/
  function () {
    var _fetch = _asyncToGenerator(
    /*#__PURE__*/
    _regeneratorRuntime.mark(function _callee(options) {
      var _makeCancelablePromis, _makeCancelablePromis2, newRequest, newCancel, token, _token;

      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              cancel.current();
              setResult(function (result) {
                switch (result.state) {
                  case 'error-initial':
                  case 'fetching-initial':
                    {
                      return {
                        state: 'fetching-initial'
                      };
                    }

                  default:
                    {
                      return {
                        data: result.data,
                        state: 'fetching'
                      };
                    }
                }
              });
              _makeCancelablePromis = makeCancelablePromise(fetchData(options)), _makeCancelablePromis2 = _slicedToArray(_makeCancelablePromis, 2), newRequest = _makeCancelablePromis2[0], newCancel = _makeCancelablePromis2[1];
              cancel.current = newCancel;
              _context.next = 7;
              return newRequest;

            case 7:
              token = _context.sent;

              if (!token.isPromiseCanceled) {
                setResult(function () {
                  return {
                    data: token.value,
                    state: 'success'
                  };
                });
              }

              _context.next = 15;
              break;

            case 11:
              _context.prev = 11;
              _context.t0 = _context["catch"](0);
              _token = _context.t0;

              if (!_token.isPromiseCanceled) {
                setResult(function (result) {
                  switch (result.state) {
                    case 'error-initial':
                    case 'fetching-initial':
                      {
                        return {
                          state: 'error-initial'
                        };
                      }

                    default:
                      {
                        return {
                          data: result.data,
                          state: 'error'
                        };
                      }
                  }
                });
              }

            case 15:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[0, 11]]);
    }));

    function fetch(_x) {
      return _fetch.apply(this, arguments);
    }

    return fetch;
  }(), [fetchData]);
  useEffect(function () {
    fetch(initialFetchDataOptions);
    return function () {
      cancel.current();
      cancel.current = noop;
    };
  }, [fetch, initialFetchDataOptions]);
  return children({
    fetch: fetch,
    result: result
  });
}
//# sourceMappingURL=FoundationDataProvider.js.map