/// <reference types="react" />
export declare type FoundationDataProviderFetchStateInitializing = 'error-initial' | 'fetching-initial';
export declare type FoundationDataProviderFetchStateInitialized = 'error' | 'fetching' | 'success';
export declare type FoundationDataProviderFetchState = FoundationDataProviderFetchStateInitializing | FoundationDataProviderFetchStateInitialized;
export interface FoundationDataProviderResultInitializing {
    state: FoundationDataProviderFetchStateInitializing;
}
export interface FoundationDataProviderResultInitialized<TData> {
    data: TData;
    state: FoundationDataProviderFetchStateInitialized;
}
export declare type FoundationDataProviderResult<TData> = FoundationDataProviderResultInitializing | FoundationDataProviderResultInitialized<TData>;
export interface FoundationDataProviderFetchHandler<TOptions = never> {
    (options?: TOptions): Promise<void>;
}
export interface FoundationDataProviderFetch<TData, TOptions = never> {
    (options?: TOptions): Promise<TData>;
}
export interface FoundationDataProviderContextType<TData, TOptions = never> {
    fetch: FoundationDataProviderFetchHandler<TOptions>;
    result: FoundationDataProviderResult<TData>;
}
export interface FoundationDataProviderProps<TData, TOptions = never> {
    children: (context: FoundationDataProviderContextType<TData, TOptions>) => React.ReactElement;
    fetchData: FoundationDataProviderFetch<TData, TOptions>;
    initialFetchDataOptions?: TOptions;
}
